Index: uspace/lib/c/generic/io/window.c
===================================================================
--- uspace/lib/c/generic/io/window.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/io/window.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,9 +40,9 @@
 #include <stdio.h>
 
-errno_t win_register(async_sess_t *sess, window_flags_t flags, service_id_t *in,
+int win_register(async_sess_t *sess, window_flags_t flags, service_id_t *in,
     service_id_t *out)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_1_2(exch, WINDOW_REGISTER, flags, in, out);
+	int ret = async_req_1_2(exch, WINDOW_REGISTER, flags, in, out);
 	async_exchange_end(exch);
 	
@@ -50,5 +50,5 @@
 }
 
-errno_t win_get_event(async_sess_t *sess, window_event_t *event)
+int win_get_event(async_sess_t *sess, window_event_t *event)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -57,9 +57,9 @@
 	aid_t req = async_send_0(exch, WINDOW_GET_EVENT, &answer);
 
-	errno_t rc = async_data_read_start(exch, event, sizeof(window_event_t));
+	int rc = async_data_read_start(exch, event, sizeof(window_event_t));
 
 	async_exchange_end(exch);
 
-	errno_t ret;
+	sysarg_t ret;
 	async_wait_for(req, &ret);
 
@@ -73,9 +73,9 @@
 }
 
-errno_t win_damage(async_sess_t *sess,
+int win_damage(async_sess_t *sess,
     sysarg_t x, sysarg_t y, sysarg_t width, sysarg_t height)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_4_0(exch, WINDOW_DAMAGE, x, y, width, height);
+	int ret = async_req_4_0(exch, WINDOW_DAMAGE, x, y, width, height);
 	async_exchange_end(exch);
 
@@ -83,8 +83,8 @@
 }
 
-errno_t win_grab(async_sess_t *sess, sysarg_t pos_id, sysarg_t grab_flags)
+int win_grab(async_sess_t *sess, sysarg_t pos_id, sysarg_t grab_flags)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_2_0(exch, WINDOW_GRAB, pos_id, grab_flags);
+	int ret = async_req_2_0(exch, WINDOW_GRAB, pos_id, grab_flags);
 	async_exchange_end(exch);
 
@@ -92,5 +92,5 @@
 }
 
-errno_t win_resize(async_sess_t *sess, sysarg_t x, sysarg_t y, sysarg_t width,
+int win_resize(async_sess_t *sess, sysarg_t x, sysarg_t y, sysarg_t width,
     sysarg_t height, window_placement_flags_t placement_flags, void *cells)
 {
@@ -101,9 +101,9 @@
 	    (sysarg_t) placement_flags, &answer);
 	
-	errno_t rc = async_share_out_start(exch, cells, AS_AREA_READ | AS_AREA_CACHEABLE);
+	int rc = async_share_out_start(exch, cells, AS_AREA_READ | AS_AREA_CACHEABLE);
 	
 	async_exchange_end(exch);
 	
-	errno_t ret;
+	sysarg_t ret;
 	async_wait_for(req, &ret);
 	
@@ -116,8 +116,8 @@
 }
 
-errno_t win_close(async_sess_t *sess)
+int win_close(async_sess_t *sess)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_0_0(exch, WINDOW_CLOSE);
+	int ret = async_req_0_0(exch, WINDOW_CLOSE);
 	async_exchange_end(exch);
 
@@ -125,8 +125,8 @@
 }
 
-errno_t win_close_request(async_sess_t *sess)
+int win_close_request(async_sess_t *sess)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
-	errno_t ret = async_req_0_0(exch, WINDOW_CLOSE_REQUEST);
+	int ret = async_req_0_0(exch, WINDOW_CLOSE_REQUEST);
 	async_exchange_end(exch);
 
Index: uspace/lib/c/generic/ipc.c
===================================================================
--- uspace/lib/c/generic/ipc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/ipc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -93,5 +93,5 @@
  * @param call     Structure returned by ipc_prepare_async().
  */
-static inline void ipc_finish_async(errno_t rc, async_call_t *call)
+static inline void ipc_finish_async(int rc, async_call_t *call)
 {
 	if (!call) {
@@ -136,5 +136,5 @@
 		return;
 	
-	errno_t rc = (errno_t) __SYSCALL6(SYS_IPC_CALL_ASYNC_FAST, phandle, imethod, arg1,
+	int rc = __SYSCALL6(SYS_IPC_CALL_ASYNC_FAST, phandle, imethod, arg1,
 	    arg2, arg3, (sysarg_t) call);
 	
@@ -175,5 +175,5 @@
 	IPC_SET_ARG5(call->msg.data, arg5);
 	
-	errno_t rc = (errno_t) __SYSCALL3(SYS_IPC_CALL_ASYNC_SLOW, phandle,
+	int rc = __SYSCALL3(SYS_IPC_CALL_ASYNC_SLOW, phandle,
 	    (sysarg_t) &call->msg.data, (sysarg_t) call);
 	
@@ -197,8 +197,8 @@
  *
  */
-errno_t ipc_answer_fast(cap_handle_t chandle, errno_t retval, sysarg_t arg1,
+sysarg_t ipc_answer_fast(cap_handle_t chandle, sysarg_t retval, sysarg_t arg1,
     sysarg_t arg2, sysarg_t arg3, sysarg_t arg4)
 {
-	return (errno_t) __SYSCALL6(SYS_IPC_ANSWER_FAST, chandle, (sysarg_t) retval, arg1, arg2,
+	return __SYSCALL6(SYS_IPC_ANSWER_FAST, chandle, retval, arg1, arg2,
 	    arg3, arg4);
 }
@@ -218,5 +218,5 @@
  *
  */
-errno_t ipc_answer_slow(cap_handle_t chandle, errno_t retval, sysarg_t arg1,
+sysarg_t ipc_answer_slow(cap_handle_t chandle, sysarg_t retval, sysarg_t arg1,
     sysarg_t arg2, sysarg_t arg3, sysarg_t arg4, sysarg_t arg5)
 {
@@ -230,5 +230,5 @@
 	IPC_SET_ARG5(data, arg5);
 	
-	return (errno_t) __SYSCALL2(SYS_IPC_ANSWER_SLOW, chandle, (sysarg_t) &data);
+	return __SYSCALL2(SYS_IPC_ANSWER_SLOW, chandle, (sysarg_t) &data);
 }
 
@@ -254,19 +254,18 @@
  * @param usec   Timeout in microseconds
  * @param flags  Flags passed to SYS_IPC_WAIT (blocking, nonblocking).
- * @param[out] out_handle  Call handle.
- *
- * @return  Error code.
- */
-errno_t ipc_wait_cycle(ipc_call_t *call, sysarg_t usec, unsigned int flags)
-{
-	errno_t rc = (errno_t) __SYSCALL3(SYS_IPC_WAIT, (sysarg_t) call, usec, flags);
+ *
+ * @return  Call handle.
+ * @return  Negative error code.
+ */
+cap_handle_t ipc_wait_cycle(ipc_call_t *call, sysarg_t usec, unsigned int flags)
+{
+	cap_handle_t chandle =
+	    __SYSCALL3(SYS_IPC_WAIT, (sysarg_t) call, usec, flags);
 	
 	/* Handle received answers */
-	if ((rc == EOK) && (call->cap_handle == CAP_NIL) &&
-	    (call->flags & IPC_CALL_ANSWERED)) {
+	if ((chandle == CAP_NIL) && (call->flags & IPC_CALL_ANSWERED))
 		handle_answer(call);
-	}
-	
-	return rc;
+	
+	return chandle;
 }
 
@@ -286,16 +285,17 @@
  * @param usec  Timeout in microseconds
  *
- * @return  Error code.
- *
- */
-errno_t ipc_wait_for_call_timeout(ipc_call_t *call, sysarg_t usec)
-{
-	errno_t rc;
+ * @return  Call handle.
+ * @return  Negative error code.
+ *
+ */
+cap_handle_t ipc_wait_for_call_timeout(ipc_call_t *call, sysarg_t usec)
+{
+	cap_handle_t chandle;
 	
 	do {
-		rc = ipc_wait_cycle(call, usec, SYNCH_FLAGS_NONE);
-	} while ((rc == EOK) && (call->cap_handle == CAP_NIL) && (call->flags & IPC_CALL_ANSWERED));
-	
-	return rc;
+		chandle = ipc_wait_cycle(call, usec, SYNCH_FLAGS_NONE);
+	} while ((chandle == CAP_NIL) && (call->flags & IPC_CALL_ANSWERED));
+	
+	return chandle;
 }
 
@@ -306,17 +306,18 @@
  * @param call  Incoming call storage.
  *
- * @return  Error code.
- *
- */
-errno_t ipc_trywait_for_call(ipc_call_t *call)
-{
-	errno_t rc;
+ * @return  Call handle.
+ * @return  Negative error code.
+ *
+ */
+cap_handle_t ipc_trywait_for_call(ipc_call_t *call)
+{
+	cap_handle_t chandle;
 	
 	do {
-		rc = ipc_wait_cycle(call, SYNCH_NO_TIMEOUT,
+		chandle = ipc_wait_cycle(call, SYNCH_NO_TIMEOUT,
 		    SYNCH_FLAGS_NON_BLOCKING);
-	} while ((rc == EOK) && (call->cap_handle == CAP_NIL) && (call->flags & IPC_CALL_ANSWERED));
-	
-	return rc;
+	} while ((chandle == CAP_NIL) && (call->flags & IPC_CALL_ANSWERED));
+	
+	return chandle;
 }
 
@@ -325,10 +326,10 @@
  * @param phandle  Handle of the phone to be hung up.
  *
- * @return  Zero on success or an error code.
- *
- */
-errno_t ipc_hangup(cap_handle_t phandle)
-{
-	return (errno_t) __SYSCALL1(SYS_IPC_HANGUP, phandle);
+ * @return  Zero on success or a negative error code.
+ *
+ */
+int ipc_hangup(cap_handle_t phandle)
+{
+	return __SYSCALL1(SYS_IPC_HANGUP, phandle);
 }
 
@@ -350,12 +351,12 @@
  *
  */
-errno_t ipc_forward_fast(cap_handle_t chandle, cap_handle_t phandle,
+int ipc_forward_fast(cap_handle_t chandle, cap_handle_t phandle,
     sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, unsigned int mode)
 {
-	return (errno_t) __SYSCALL6(SYS_IPC_FORWARD_FAST, chandle, phandle, imethod, arg1,
+	return __SYSCALL6(SYS_IPC_FORWARD_FAST, chandle, phandle, imethod, arg1,
 	    arg2, mode);
 }
 
-errno_t ipc_forward_slow(cap_handle_t chandle, cap_handle_t phandle,
+int ipc_forward_slow(cap_handle_t chandle, cap_handle_t phandle,
     sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, sysarg_t arg3,
     sysarg_t arg4, sysarg_t arg5, unsigned int mode)
@@ -370,5 +371,5 @@
 	IPC_SET_ARG5(data, arg5);
 	
-	return (errno_t) __SYSCALL4(SYS_IPC_FORWARD_SLOW, chandle, phandle,
+	return __SYSCALL4(SYS_IPC_FORWARD_SLOW, chandle, phandle,
 	    (sysarg_t) &data, mode);
 }
@@ -377,7 +378,14 @@
  *
  */
-errno_t ipc_connect_kbox(task_id_t id, cap_handle_t *phone)
-{
-	return (errno_t) __SYSCALL2(SYS_IPC_CONNECT_KBOX, (sysarg_t) &id, (sysarg_t) phone);
+int ipc_connect_kbox(task_id_t id)
+{
+#ifdef __32_BITS__
+	sysarg64_t arg = (sysarg64_t) id;
+	return __SYSCALL1(SYS_IPC_CONNECT_KBOX, (sysarg_t) &arg);
+#endif
+	
+#ifdef __64_BITS__
+	return __SYSCALL1(SYS_IPC_CONNECT_KBOX, (sysarg_t) id);
+#endif
 }
 
Index: uspace/lib/c/generic/iplink.c
===================================================================
--- uspace/lib/c/generic/iplink.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/iplink.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,5 +47,5 @@
 static void iplink_cb_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg);
 
-errno_t iplink_open(async_sess_t *sess, iplink_ev_ops_t *ev_ops, void *arg,
+int iplink_open(async_sess_t *sess, iplink_ev_ops_t *ev_ops, void *arg,
     iplink_t **riplink)
 {
@@ -61,5 +61,5 @@
 
 	port_id_t port;
-	errno_t rc = async_create_callback_port(exch, INTERFACE_IPLINK_CB, 0, 0,
+	int rc = async_create_callback_port(exch, INTERFACE_IPLINK_CB, 0, 0,
 	    iplink_cb_conn, iplink, &port);
 	
@@ -85,5 +85,5 @@
 }
 
-errno_t iplink_send(iplink_t *iplink, iplink_sdu_t *sdu)
+int iplink_send(iplink_t *iplink, iplink_sdu_t *sdu)
 {
 	async_exch_t *exch = async_exchange_begin(iplink->sess);
@@ -93,20 +93,20 @@
 	    (sysarg_t) sdu->dest, &answer);
 	
-	errno_t rc = async_data_write_start(exch, sdu->data, sdu->size);
-	
-	async_exchange_end(exch);
-	
-	if (rc != EOK) {
-		async_forget(req);
-		return rc;
-	}
-	
-	errno_t retval;
-	async_wait_for(req, &retval);
-	
-	return retval;
-}
-
-errno_t iplink_send6(iplink_t *iplink, iplink_sdu6_t *sdu)
+	int rc = async_data_write_start(exch, sdu->data, sdu->size);
+	
+	async_exchange_end(exch);
+	
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+	
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+	
+	return (int) retval;
+}
+
+int iplink_send6(iplink_t *iplink, iplink_sdu6_t *sdu)
 {
 	async_exch_t *exch = async_exchange_begin(iplink->sess);
@@ -115,5 +115,5 @@
 	aid_t req = async_send_0(exch, IPLINK_SEND6, &answer);
 	
-	errno_t rc = async_data_write_start(exch, &sdu->dest, sizeof(addr48_t));
+	int rc = async_data_write_start(exch, &sdu->dest, sizeof(addr48_t));
 	if (rc != EOK) {
 		async_exchange_end(exch);
@@ -131,16 +131,16 @@
 	}
 	
-	errno_t retval;
-	async_wait_for(req, &retval);
-	
-	return retval;
-}
-
-errno_t iplink_get_mtu(iplink_t *iplink, size_t *rmtu)
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+	
+	return (int) retval;
+}
+
+int iplink_get_mtu(iplink_t *iplink, size_t *rmtu)
 {
 	async_exch_t *exch = async_exchange_begin(iplink->sess);
 	
 	sysarg_t mtu;
-	errno_t rc = async_req_0_1(exch, IPLINK_GET_MTU, &mtu);
+	int rc = async_req_0_1(exch, IPLINK_GET_MTU, &mtu);
 	
 	async_exchange_end(exch);
@@ -153,5 +153,5 @@
 }
 
-errno_t iplink_get_mac48(iplink_t *iplink, addr48_t *mac)
+int iplink_get_mac48(iplink_t *iplink, addr48_t *mac)
 {
 	async_exch_t *exch = async_exchange_begin(iplink->sess);
@@ -160,5 +160,5 @@
 	aid_t req = async_send_0(exch, IPLINK_GET_MAC48, &answer);
 	
-	errno_t rc = async_data_read_start(exch, mac, sizeof(addr48_t));
+	int rc = async_data_read_start(exch, mac, sizeof(addr48_t));
 	
 	loc_exchange_end(exch);
@@ -169,11 +169,11 @@
 	}
 	
-	errno_t retval;
-	async_wait_for(req, &retval);
-	
-	return retval;
-}
-
-errno_t iplink_set_mac48(iplink_t *iplink, addr48_t mac)
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+	
+	return (int) retval;
+}
+
+int iplink_set_mac48(iplink_t *iplink, addr48_t mac)
 {
 	async_exch_t *exch = async_exchange_begin(iplink->sess);
@@ -182,5 +182,5 @@
 	aid_t req = async_send_0(exch, IPLINK_GET_MAC48, &answer);
 	
-	errno_t rc = async_data_read_start(exch, mac, sizeof(addr48_t));
+	int rc = async_data_read_start(exch, mac, sizeof(addr48_t));
 	
 	loc_exchange_end(exch);
@@ -191,12 +191,12 @@
 	}
 	
-	errno_t retval;
-	async_wait_for(req, &retval);
-	
-	return retval;
-}
-
-
-errno_t iplink_addr_add(iplink_t *iplink, inet_addr_t *addr)
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+	
+	return (int) retval;
+}
+
+
+int iplink_addr_add(iplink_t *iplink, inet_addr_t *addr)
 {
 	async_exch_t *exch = async_exchange_begin(iplink->sess);
@@ -205,19 +205,19 @@
 	aid_t req = async_send_0(exch, IPLINK_ADDR_ADD, &answer);
 	
-	errno_t rc = async_data_write_start(exch, addr, sizeof(inet_addr_t));
-	async_exchange_end(exch);
-	
-	if (rc != EOK) {
-		async_forget(req);
-		return rc;
-	}
-	
-	errno_t retval;
-	async_wait_for(req, &retval);
-	
-	return retval;
-}
-
-errno_t iplink_addr_remove(iplink_t *iplink, inet_addr_t *addr)
+	int rc = async_data_write_start(exch, addr, sizeof(inet_addr_t));
+	async_exchange_end(exch);
+	
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+	
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+	
+	return (int) retval;
+}
+
+int iplink_addr_remove(iplink_t *iplink, inet_addr_t *addr)
 {
 	async_exch_t *exch = async_exchange_begin(iplink->sess);
@@ -226,16 +226,16 @@
 	aid_t req = async_send_0(exch, IPLINK_ADDR_REMOVE, &answer);
 	
-	errno_t rc = async_data_write_start(exch, addr, sizeof(inet_addr_t));
-	async_exchange_end(exch);
-	
-	if (rc != EOK) {
-		async_forget(req);
-		return rc;
-	}
-	
-	errno_t retval;
-	async_wait_for(req, &retval);
-	
-	return retval;
+	int rc = async_data_write_start(exch, addr, sizeof(inet_addr_t));
+	async_exchange_end(exch);
+	
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+	
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+	
+	return (int) retval;
 }
 
@@ -252,5 +252,5 @@
 	ip_ver_t ver = IPC_GET_ARG1(*icall);
 	
-	errno_t rc = async_data_write_accept(&sdu.data, false, 0, 0, 0,
+	int rc = async_data_write_accept(&sdu.data, false, 0, 0, 0,
 	    &sdu.size);
 	if (rc != EOK) {
@@ -270,5 +270,5 @@
 	size_t size;
 	
-	errno_t rc = async_data_write_accept((void **)&addr, false,
+	int rc = async_data_write_accept((void **)&addr, false,
 	    sizeof(addr48_t), sizeof(addr48_t), 0, &size);
 	if (rc != EOK) {
Index: uspace/lib/c/generic/iplink_srv.c
===================================================================
--- uspace/lib/c/generic/iplink_srv.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/iplink_srv.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,5 +46,5 @@
 {
 	size_t mtu;
-	errno_t rc = srv->ops->get_mtu(srv, &mtu);
+	int rc = srv->ops->get_mtu(srv, &mtu);
 	async_answer_1(callid, rc, mtu);
 }
@@ -54,5 +54,5 @@
 {
 	addr48_t mac;
-	errno_t rc = srv->ops->get_mac48(srv, &mac);
+	int rc = srv->ops->get_mac48(srv, &mac);
 	if (rc != EOK) {
 		async_answer_0(iid, rc);
@@ -78,5 +78,5 @@
 		async_answer_0(callid, rc);
 	
-	async_answer_0(iid, rc);
+	async_answer_0(iid, (sysarg_t) rc);
 }
 
@@ -84,28 +84,57 @@
     ipc_call_t *icall)
 {
-	errno_t rc;
+	int rc;
 	size_t size;
 	addr48_t mac;
 	ipc_callid_t callid;
 
+	rc = async_data_write_receive(&callid, &size);
+	if (rc != EOK) {
+		async_answer_0(callid, (sysarg_t) rc);
+		async_answer_0(iid, (sysarg_t) rc);
+	}
+
+	rc = srv->ops->set_mac48(srv, &mac);
+	if (rc != EOK) {
+		async_answer_0(iid, rc);
+		return;
+	}
+	
+	rc = async_data_read_finalize(callid, &mac, sizeof(addr48_t));
+	if (rc != EOK)
+		async_answer_0(callid, rc);
+	
+	async_answer_0(iid, (sysarg_t) rc);
+}
+
+static void iplink_addr_add_srv(iplink_srv_t *srv, ipc_callid_t iid,
+    ipc_call_t *icall)
+{
+	ipc_callid_t callid;
+	size_t size;
 	if (!async_data_write_receive(&callid, &size)) {
 		async_answer_0(callid, EREFUSED);
 		async_answer_0(iid, EREFUSED);
-	}
-
-	rc = srv->ops->set_mac48(srv, &mac);
-	if (rc != EOK) {
-		async_answer_0(iid, rc);
-		return;
-	}
-	
-	rc = async_data_read_finalize(callid, &mac, sizeof(addr48_t));
-	if (rc != EOK)
-		async_answer_0(callid, rc);
-	
-	async_answer_0(iid, rc);
-}
-
-static void iplink_addr_add_srv(iplink_srv_t *srv, ipc_callid_t iid,
+		return;
+	}
+	
+	if (size != sizeof(inet_addr_t)) {
+		async_answer_0(callid, EINVAL);
+		async_answer_0(iid, EINVAL);
+		return;
+	}
+	
+	inet_addr_t addr;
+	int rc = async_data_write_finalize(callid, &addr, size);
+	if (rc != EOK) {
+		async_answer_0(callid, (sysarg_t) rc);
+		async_answer_0(iid, (sysarg_t) rc);
+	}
+	
+	rc = srv->ops->addr_add(srv, &addr);
+	async_answer_0(iid, (sysarg_t) rc);
+}
+
+static void iplink_addr_remove_srv(iplink_srv_t *srv, ipc_callid_t iid,
     ipc_call_t *icall)
 {
@@ -125,17 +154,39 @@
 	
 	inet_addr_t addr;
-	errno_t rc = async_data_write_finalize(callid, &addr, size);
-	if (rc != EOK) {
-		async_answer_0(callid, rc);
+	int rc = async_data_write_finalize(callid, &addr, size);
+	if (rc != EOK) {
+		async_answer_0(callid, (sysarg_t) rc);
+		async_answer_0(iid, (sysarg_t) rc);
+	}
+	
+	rc = srv->ops->addr_remove(srv, &addr);
+	async_answer_0(iid, (sysarg_t) rc);
+}
+
+static void iplink_send_srv(iplink_srv_t *srv, ipc_callid_t iid,
+    ipc_call_t *icall)
+{
+	iplink_sdu_t sdu;
+	
+	sdu.src = IPC_GET_ARG1(*icall);
+	sdu.dest = IPC_GET_ARG2(*icall);
+	
+	int rc = async_data_write_accept(&sdu.data, false, 0, 0, 0,
+	    &sdu.size);
+	if (rc != EOK) {
 		async_answer_0(iid, rc);
-	}
-	
-	rc = srv->ops->addr_add(srv, &addr);
+		return;
+	}
+	
+	rc = srv->ops->send(srv, &sdu);
+	free(sdu.data);
 	async_answer_0(iid, rc);
 }
 
-static void iplink_addr_remove_srv(iplink_srv_t *srv, ipc_callid_t iid,
-    ipc_call_t *icall)
-{
+static void iplink_send6_srv(iplink_srv_t *srv, ipc_callid_t iid,
+    ipc_call_t *icall)
+{
+	iplink_sdu6_t sdu;
+	
 	ipc_callid_t callid;
 	size_t size;
@@ -146,54 +197,4 @@
 	}
 	
-	if (size != sizeof(inet_addr_t)) {
-		async_answer_0(callid, EINVAL);
-		async_answer_0(iid, EINVAL);
-		return;
-	}
-	
-	inet_addr_t addr;
-	errno_t rc = async_data_write_finalize(callid, &addr, size);
-	if (rc != EOK) {
-		async_answer_0(callid, rc);
-		async_answer_0(iid, rc);
-	}
-	
-	rc = srv->ops->addr_remove(srv, &addr);
-	async_answer_0(iid, rc);
-}
-
-static void iplink_send_srv(iplink_srv_t *srv, ipc_callid_t iid,
-    ipc_call_t *icall)
-{
-	iplink_sdu_t sdu;
-	
-	sdu.src = IPC_GET_ARG1(*icall);
-	sdu.dest = IPC_GET_ARG2(*icall);
-	
-	errno_t rc = async_data_write_accept(&sdu.data, false, 0, 0, 0,
-	    &sdu.size);
-	if (rc != EOK) {
-		async_answer_0(iid, rc);
-		return;
-	}
-	
-	rc = srv->ops->send(srv, &sdu);
-	free(sdu.data);
-	async_answer_0(iid, rc);
-}
-
-static void iplink_send6_srv(iplink_srv_t *srv, ipc_callid_t iid,
-    ipc_call_t *icall)
-{
-	iplink_sdu6_t sdu;
-	
-	ipc_callid_t callid;
-	size_t size;
-	if (!async_data_write_receive(&callid, &size)) {
-		async_answer_0(callid, EREFUSED);
-		async_answer_0(iid, EREFUSED);
-		return;
-	}
-	
 	if (size != sizeof(addr48_t)) {
 		async_answer_0(callid, EINVAL);
@@ -202,8 +203,8 @@
 	}
 	
-	errno_t rc = async_data_write_finalize(callid, &sdu.dest, size);
-	if (rc != EOK) {
-		async_answer_0(callid, rc);
-		async_answer_0(iid, rc);
+	int rc = async_data_write_finalize(callid, &sdu.dest, size);
+	if (rc != EOK) {
+		async_answer_0(callid, (sysarg_t) rc);
+		async_answer_0(iid, (sysarg_t) rc);
 	}
 	
@@ -229,8 +230,8 @@
 }
 
-errno_t iplink_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg)
+int iplink_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
 	iplink_srv_t *srv = (iplink_srv_t *) arg;
-	errno_t rc;
+	int rc;
 	
 	fibril_mutex_lock(&srv->lock);
@@ -302,5 +303,5 @@
 
 /* XXX Version should be part of @a sdu */
-errno_t iplink_ev_recv(iplink_srv_t *srv, iplink_recv_sdu_t *sdu, ip_ver_t ver)
+int iplink_ev_recv(iplink_srv_t *srv, iplink_recv_sdu_t *sdu, ip_ver_t ver)
 {
 	if (srv->client_sess == NULL)
@@ -313,5 +314,5 @@
 	    &answer);
 	
-	errno_t rc = async_data_write_start(exch, sdu->data, sdu->size);
+	int rc = async_data_write_start(exch, sdu->data, sdu->size);
 	async_exchange_end(exch);
 	
@@ -321,5 +322,5 @@
 	}
 	
-	errno_t retval;
+	sysarg_t retval;
 	async_wait_for(req, &retval);
 	if (retval != EOK)
@@ -329,5 +330,5 @@
 }
 
-errno_t iplink_ev_change_addr(iplink_srv_t *srv, addr48_t *addr)
+int iplink_ev_change_addr(iplink_srv_t *srv, addr48_t *addr)
 {
 	if (srv->client_sess == NULL)
@@ -339,5 +340,5 @@
 	aid_t req = async_send_0(exch, IPLINK_EV_CHANGE_ADDR, &answer);
 	
-	errno_t rc = async_data_write_start(exch, addr, sizeof(addr48_t));
+	int rc = async_data_write_start(exch, addr, sizeof(addr48_t));
 	async_exchange_end(exch);
 	
@@ -347,5 +348,5 @@
 	}
 	
-	errno_t retval;
+	sysarg_t retval;
 	async_wait_for(req, &retval);
 	if (retval != EOK)
Index: uspace/lib/c/generic/irc.c
===================================================================
--- uspace/lib/c/generic/irc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/irc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,10 +49,10 @@
  * @return	EOK on success, EIO on failure
  */
-static errno_t irc_init(void)
+static int irc_init(void)
 {
 	category_id_t irc_cat;
 	service_id_t *svcs;
 	size_t count;
-	errno_t rc;
+	int rc;
 
 	assert(irc_sess == NULL);
@@ -91,7 +91,7 @@
  * @param irq	IRQ number
  */
-errno_t irc_enable_interrupt(int irq)
+int irc_enable_interrupt(int irq)
 {
-	errno_t rc;
+	int rc;
 
 	if (irc_sess == NULL) {
@@ -114,7 +114,7 @@
  * @param irq	IRQ number
  */
-errno_t irc_disable_interrupt(int irq)
+int irc_disable_interrupt(int irq)
 {
-	errno_t rc;
+	int rc;
 
 	if (irc_sess == NULL) {
@@ -138,7 +138,7 @@
  * @param irq	IRQ number
  */
-errno_t irc_clear_interrupt(int irq)
+int irc_clear_interrupt(int irq)
 {
-	errno_t rc;
+	int rc;
 
 	if (irc_sess == NULL) {
Index: uspace/lib/c/generic/irq.c
===================================================================
--- uspace/lib/c/generic/irq.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/irq.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,17 +58,14 @@
  * @param ucode  Top-half pseudocode handler.
  *
- * @param[out] out_handle  IRQ capability handle returned by the kernel.
- *
+ * @return IRQ capability handle returned by the kernel.
  * @return Error code returned by the kernel.
  *
  */
-errno_t ipc_irq_subscribe(int inr, sysarg_t method, const irq_code_t *ucode,
-    cap_handle_t *out_handle)
+int ipc_irq_subscribe(int inr, sysarg_t method, const irq_code_t *ucode)
 {
 	if (ucode == NULL)
 		ucode = &default_ucode;
 	
-	return (errno_t) __SYSCALL4(SYS_IPC_IRQ_SUBSCRIBE, inr, method, (sysarg_t) ucode,
-	    (sysarg_t) out_handle);
+	return __SYSCALL3(SYS_IPC_IRQ_SUBSCRIBE, inr, method, (sysarg_t) ucode);
 }
 
@@ -80,7 +77,7 @@
  *
  */
-errno_t ipc_irq_unsubscribe(cap_handle_t cap)
+int ipc_irq_unsubscribe(int cap)
 {
-	return (errno_t) __SYSCALL1(SYS_IPC_IRQ_UNSUBSCRIBE, cap);
+	return __SYSCALL1(SYS_IPC_IRQ_UNSUBSCRIBE, cap);
 }
 
Index: uspace/lib/c/generic/loader.c
===================================================================
--- uspace/lib/c/generic/loader.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/loader.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,9 +52,11 @@
  * @param name Symbolic name to set on the newly created task.
  *
- * @return Error code.
- */
-errno_t loader_spawn(const char *name)
-{
-	return (errno_t) __SYSCALL2(SYS_PROGRAM_SPAWN_LOADER,
+ * @return Pointer to the loader connection structure (should be
+ *         deallocated using free() after use).
+ *
+ */
+int loader_spawn(const char *name)
+{
+	return __SYSCALL2(SYS_PROGRAM_SPAWN_LOADER,
 	    (sysarg_t) name, str_size(name));
 }
@@ -84,8 +86,8 @@
  * @param task_id Points to a variable where the ID should be stored.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t loader_get_task_id(loader_t *ldr, task_id_t *task_id)
+ * @return Zero on success or negative error code.
+ *
+ */
+int loader_get_task_id(loader_t *ldr, task_id_t *task_id)
 {
 	/* Get task ID. */
@@ -94,5 +96,5 @@
 	ipc_call_t answer;
 	aid_t req = async_send_0(exch, LOADER_GET_TASKID, &answer);
-	errno_t rc = async_data_read_start(exch, task_id, sizeof(task_id_t));
+	sysarg_t rc = async_data_read_start(exch, task_id, sizeof(task_id_t));
 	
 	async_exchange_end(exch);
@@ -100,9 +102,9 @@
 	if (rc != EOK) {
 		async_forget(req);
-		return (errno_t) rc;
+		return (int) rc;
 	}
 	
 	async_wait_for(req, &rc);
-	return (errno_t) rc;
+	return (int) rc;
 }
 
@@ -113,8 +115,8 @@
  * @param ldr  Loader connection structure.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t loader_set_cwd(loader_t *ldr)
+ * @return Zero on success or negative error code.
+ *
+ */
+int loader_set_cwd(loader_t *ldr)
 {
 	char *cwd = (char *) malloc(MAX_PATH_LEN + 1);
@@ -131,5 +133,5 @@
 	ipc_call_t answer;
 	aid_t req = async_send_0(exch, LOADER_SET_CWD, &answer);
-	errno_t rc = async_data_write_start(exch, cwd, len);
+	sysarg_t rc = async_data_write_start(exch, cwd, len);
 	
 	async_exchange_end(exch);
@@ -138,9 +140,9 @@
 	if (rc != EOK) {
 		async_forget(req);
-		return (errno_t) rc;
+		return (int) rc;
 	}
 	
 	async_wait_for(req, &rc);
-	return (errno_t) rc;
+	return (int) rc;
 }
 
@@ -151,8 +153,8 @@
  * @param file Program file.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t loader_set_program(loader_t *ldr, const char *name, int file)
+ * @return Zero on success or negative error code.
+ *
+ */
+int loader_set_program(loader_t *ldr, const char *name, int file)
 {
 	async_exch_t *exch = async_exchange_begin(ldr->sess);
@@ -161,5 +163,5 @@
 	aid_t req = async_send_0(exch, LOADER_SET_PROGRAM, &answer);
 
-	errno_t rc = async_data_write_start(exch, name, str_size(name) + 1);
+	sysarg_t rc = async_data_write_start(exch, name, str_size(name) + 1);
 	if (rc == EOK) {
 		async_exch_t *vfs_exch = vfs_exchange_begin();
@@ -172,9 +174,9 @@
 	if (rc != EOK) {
 		async_forget(req);
-		return (errno_t) rc;
+		return (int) rc;
 	}
 
 	async_wait_for(req, &rc);
-	return (errno_t) rc;
+	return (int) rc;
 }
 
@@ -184,8 +186,8 @@
  * @param path Program path.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t loader_set_program_path(loader_t *ldr, const char *path)
+ * @return Zero on success or negative error code.
+ *
+ */
+int loader_set_program_path(loader_t *ldr, const char *path)
 {
 	const char *name = str_rchr(path, '/');
@@ -196,11 +198,10 @@
 	}
 	
-	int fd;
-	errno_t rc = vfs_lookup(path, 0, &fd);
-	if (rc != EOK) {
-		return rc;
-	}
-	
-	rc = loader_set_program(ldr, name, fd);
+	int fd = vfs_lookup(path, 0);
+	if (fd < 0) {
+		return fd;
+	}
+	
+	int rc = loader_set_program(ldr, name, fd);
 	vfs_put(fd);
 	return rc;
@@ -217,8 +218,8 @@
  * @param argv NULL-terminated array of pointers to arguments.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t loader_set_args(loader_t *ldr, const char *const argv[])
+ * @return Zero on success or negative error code.
+ *
+ */
+int loader_set_args(loader_t *ldr, const char *const argv[])
 {
 	/*
@@ -252,5 +253,5 @@
 	ipc_call_t answer;
 	aid_t req = async_send_0(exch, LOADER_SET_ARGS, &answer);
-	errno_t rc = async_data_write_start(exch, (void *) arg_buf,
+	sysarg_t rc = async_data_write_start(exch, (void *) arg_buf,
 	    buffer_size);
 	
@@ -260,9 +261,9 @@
 	if (rc != EOK) {
 		async_forget(req);
-		return (errno_t) rc;
+		return (int) rc;
 	}
 	
 	async_wait_for(req, &rc);
-	return (errno_t) rc;
+	return (int) rc;
 }
 
@@ -273,8 +274,8 @@
  * @param file       The file's descriptor.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t loader_add_inbox(loader_t *ldr, const char *name, int file)
+ * @return Zero on success or negative error code.
+ *
+ */
+int loader_add_inbox(loader_t *ldr, const char *name, int file)
 {
 	async_exch_t *exch = async_exchange_begin(ldr->sess);
@@ -283,5 +284,5 @@
 	aid_t req = async_send_0(exch, LOADER_ADD_INBOX, NULL);
 	
-	errno_t rc = async_data_write_start(exch, name, str_size(name) + 1);
+	sysarg_t rc = async_data_write_start(exch, name, str_size(name) + 1);
 	if (rc == EOK) {
 		rc = vfs_pass_handle(vfs_exch, file, exch);
@@ -297,5 +298,5 @@
 	}
 	
-	return (errno_t) rc;
+	return (int) rc;
 }
 
@@ -307,11 +308,11 @@
  * @param ldr Loader connection structure.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t loader_load_program(loader_t *ldr)
-{
-	async_exch_t *exch = async_exchange_begin(ldr->sess);
-	errno_t rc = async_req_0_0(exch, LOADER_LOAD);
+ * @return Zero on success or negative error code.
+ *
+ */
+int loader_load_program(loader_t *ldr)
+{
+	async_exch_t *exch = async_exchange_begin(ldr->sess);
+	int rc = async_req_0_0(exch, LOADER_LOAD);
 	async_exchange_end(exch);
 	
@@ -330,11 +331,11 @@
  * @param ldr Loader connection structure.
  *
- * @return Zero on success or an error code.
- *
- */
-errno_t loader_run(loader_t *ldr)
-{
-	async_exch_t *exch = async_exchange_begin(ldr->sess);
-	errno_t rc = async_req_0_0(exch, LOADER_RUN);
+ * @return Zero on success or negative error code.
+ *
+ */
+int loader_run(loader_t *ldr)
+{
+	async_exch_t *exch = async_exchange_begin(ldr->sess);
+	int rc = async_req_0_0(exch, LOADER_RUN);
 	async_exchange_end(exch);
 	
@@ -356,5 +357,5 @@
  * @param ldr Loader connection structure.
  *
- * @return Zero on success or an error code.
+ * @return Zero on success or negative error code.
  *
  */
